<template>
  <div>
    <!-- Archive -->
    <CoscineFormGroup
      label-class="align-self-center"
      label-for="Archive"
      :label="$t('page.settings.actions.resourceArchiveLabel')"
      :is-loading="isLoading"
      info
    >
      <template #popover>
        {{ $t("page.settings.actions.archivePopover") }}
        <b-link
          :href="$t('page.settings.actions.archivePopoverUrl').toString()"
          target="_blank"
        >
          {{ $t("default.help") }}
        </b-link>
      </template>

      <b-form-checkbox
        id="Archive"
        v-model="archivedStatus"
        :disabled="!isUserAllowedToEdit"
        switch
        size="lg"
        @update:modelValue="showArchiveModal"
      />
    </CoscineFormGroup>

    <!-- Local Metadata Copy -->
    <CoscineFormGroup
      v-if="
        resourceTypeInformation && resourceTypeInformation.canCopyLocalMetadata
      "
      label-class="align-self-center"
      label-for="LocalMetadataCopy"
      :label="$t('page.settings.actions.localMetadataCopyLabel')"
      :is-loading="isLoading"
    >
      <!-- Popover template deactivated for now; currently no help webpage available; add info prop above -->
      <!-- <template #popover>
        {{ $t("page.settings.actions.localMetadataCopyPopover") }}
        <b-link
          :href="
            $t('page.settings.actions.localMetadataCopyPopoverUrl').toString()
          "
          target="_blank"
        >
          {{ $t("default.help") }}
        </b-link>
      </template> -->

      <template #hint>
        <span>{{ $t("page.settings.actions.localMetadataCopyHint") }}</span>
      </template>

      <b-form-checkbox
        id="LocalMetadataCopy"
        v-model="localMetadataCopyStatus"
        :disabled="!isUserAllowedToEdit"
        switch
        size="lg"
        @update:modelValue="showLocalMetadataCopyModal"
      />
    </CoscineFormGroup>

    <!-- Delete Resource -->
    <CoscineFormGroup
      label-for="DeleteResource"
      :label="$t('page.settings.actions.resourceDeleteLabel')"
      :is-loading="isLoading"
    >
      <!-- Delete Button -->
      <b-button
        id="DeleteResource"
        variant="danger"
        :disabled="
          !isUserAllowedToEdit ||
          (resourceTypeInformation && !resourceTypeInformation.canDelete)
        "
        @click.prevent="isDeleteModalVisible = true"
      >
        {{ $t("buttons.delete") }}
      </b-button>
    </CoscineFormGroup>

    <!-- Archive Resource Modal -->
    <ArchiveResourceModal
      :open="isArchiveModalVisible"
      :archived="resourceForUpdate.archived"
      @close="isArchiveModalVisible = false"
      @toggleArchive="toggleArchive"
    />

    <!-- Delete Resource Modal -->
    <DeleteResourceModal
      :open="isDeleteModalVisible"
      :display-name="resourceForUpdate.displayName ?? undefined"
      @close="isDeleteModalVisible = false"
      @clickDelete="clickDelete"
    />

    <!-- Local Metadata Copy Modal -->
    <LocalMetadataCopyModal
      :open="isLocalMetadataCopyModalVisible"
      :metadata-local-copy="resourceForUpdate.metadataLocalCopy"
      @close="isLocalMetadataCopyModalVisible = false"
      @toggleLocalMetadataCopy="toggleLocalMetadataCopy"
    />
  </div>
</template>

<script lang="ts">
import useProjectStore from "@/modules/project/store";
import useResourceStore from "../../store";
import ArchiveResourceModal from "./modals/ArchiveResourceModal.vue";
import DeleteResourceModal from "./modals/DeleteResourceModal.vue";
import LocalMetadataCopyModal from "./modals/LocalMetadataCopyModal.vue";
import type {
  ResourceDto,
  ResourceForUpdateDto,
  ResourceTypeInformationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  components: {
    ArchiveResourceModal,
    LocalMetadataCopyModal,
    DeleteResourceModal,
  },
  props: {
    resourceForUpdate: {
      type: Object as PropType<ResourceForUpdateDto>,
      required: true,
    },
    isLoading: {
      default: false,
      type: Boolean,
    },
    isUserAllowedToEdit: {
      default: false,
      type: Boolean,
    },
  },

  emits: {
    toggleArchive: null,
    toggleLocalMetadataCopy: null,
    clickDelete: null,
  },

  setup() {
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();

    return { projectStore, resourceStore };
  },

  data() {
    return {
      archivedStatus: this.resourceForUpdate.archived,
      localMetadataCopyStatus: this.resourceForUpdate.metadataLocalCopy,
      isLocalMetadataCopyModalVisible: false,
      isArchiveModalVisible: false,
      isDeleteModalVisible: false,
    };
  },

  computed: {
    resource(): null | ResourceDto {
      return this.resourceStore.currentResource;
    },
    resourceTypeInformation(): ResourceTypeInformationDto | undefined {
      return this.resourceStore.enabledResourceTypes?.find(
        (resourceType) => resourceType.id === this.resource?.type?.id,
      );
    },
  },

  methods: {
    showArchiveModal() {
      this.isArchiveModalVisible = true;
      setTimeout(
        () => (this.archivedStatus = this.resourceForUpdate.archived),
        1,
      ); // Reset status on checkbox click
    },
    showLocalMetadataCopyModal() {
      this.isLocalMetadataCopyModalVisible = true;
      setTimeout(
        () =>
          (this.localMetadataCopyStatus =
            this.resourceForUpdate.metadataLocalCopy),
        1,
      ); // Reset status on checkbox click
    },
    toggleArchive() {
      this.$emit("toggleArchive");
      this.isArchiveModalVisible = false;
    },
    toggleLocalMetadataCopy() {
      this.$emit("toggleLocalMetadataCopy");
      this.isLocalMetadataCopyModalVisible = false;
    },
    clickDelete() {
      this.$emit("clickDelete");
      this.isDeleteModalVisible = false;
    },
  },
});
</script>

<style scoped>
.btn-danger.disabled {
  pointer-events: none;
}
</style>
